#version 430

layout(binding = 0, std140) uniform UBO
{
    mat4 MVP;
    float crt_gamma;
    float lcd_gamma;
    float levels_contrast;
    float halation_weight;
    float diffusion_weight;
    float bloom_underestimate_levels;
    float bloom_excess;
    float beam_min_sigma;
    float beam_max_sigma;
    float beam_spot_power;
    float beam_min_shape;
    float beam_max_shape;
    float beam_shape_power;
    float beam_horiz_filter;
    float beam_horiz_sigma;
    float beam_horiz_linear_rgb_weight;
    float convergence_offset_x_r;
    float convergence_offset_x_g;
    float convergence_offset_x_b;
    float convergence_offset_y_r;
    float convergence_offset_y_g;
    float convergence_offset_y_b;
    float mask_type;
    float mask_sample_mode_desired;
    float mask_num_triads_desired;
    float mask_triad_size_desired;
    float mask_specify_num_triads;
    float aa_subpixel_r_offset_x_runtime;
    float aa_subpixel_r_offset_y_runtime;
    float aa_cubic_c;
    float aa_gauss_sigma;
    float geom_mode_runtime;
    float geom_radius;
    float geom_view_dist;
    float geom_tilt_angle_x;
    float geom_tilt_angle_y;
    float geom_aspect_ratio_x;
    float geom_aspect_ratio_y;
    float geom_overscan_x;
    float geom_overscan_y;
    float border_size;
    float border_darkness;
    float border_compress;
    float interlace_bff;
    float interlace_1080i;
    float interlace_detect_toggle;
} global;

struct Push
{
    vec4 SourceSize;
    vec4 OriginalSize;
    vec4 OutputSize;
    uint FrameCount;
};

uniform Push params;

layout(binding = 2) uniform sampler2D Source;

layout(location = 1) in vec2 uv_step;
layout(location = 0) in vec2 tex_uv;
layout(location = 2) in float interlaced;
layout(location = 0) out vec4 FragColor;
float crt_gamma_static;
float lcd_gamma_static;
float levels_contrast_static;
float levels_autodim_temp;
float halation_weight_static;
float diffusion_weight_static;
float bloom_underestimate_levels_static;
float bloom_excess_static;
float bloom_approx_filter_static;
float beam_num_scanlines;
bool beam_generalized_gaussian;
float beam_antialias_level;
float beam_min_sigma_static;
float beam_max_sigma_static;
float beam_spot_shape_function;
float beam_spot_power_static;
float beam_min_shape_static;
float beam_max_shape_static;
float beam_shape_power_static;
float beam_horiz_filter_static;
float beam_horiz_sigma_static;
float beam_horiz_linear_rgb_weight_static;
bool beam_misconvergence;
vec2 convergence_offsets_r_static;
vec2 convergence_offsets_g_static;
vec2 convergence_offsets_b_static;
bool interlace_detect_static;
bool interlace_1080i_static;
bool interlace_bff_static;
float aa_level;
float aa_filter;
bool aa_temporal;
vec2 aa_subpixel_r_offset_static;
float aa_cubic_c_static;
float aa_gauss_sigma_static;
float mask_type_static;
float mask_sample_mode_static;
float mask_specify_num_triads_static;
float mask_triad_size_desired_static;
float mask_num_triads_desired_static;
float mask_sinc_lobes;
float mask_min_allowed_triad_size;
float geom_mode_static;
float geom_radius_static;
float geom_view_dist_static;
vec2 geom_tilt_angle_static;
float geom_aspect_ratio_static;
vec2 geom_overscan_static;
bool geom_force_correct_tangent_matrix;
float border_size_static;
float border_darkness_static;
float border_compress_static;
float global_crt_gamma;
float global_lcd_gamma;
float global_levels_contrast;
float global_halation_weight;
float global_diffusion_weight;
float global_bloom_underestimate_levels;
float global_bloom_excess;
float global_beam_min_sigma;
float global_beam_max_sigma;
float global_beam_spot_power;
float global_beam_min_shape;
float global_beam_max_shape;
float global_beam_shape_power;
float global_beam_horiz_filter;
float global_beam_horiz_sigma;
float global_beam_horiz_linear_rgb_weight;
float global_convergence_offset_x_r;
float global_convergence_offset_x_g;
float global_convergence_offset_x_b;
float global_convergence_offset_y_r;
float global_convergence_offset_y_g;
float global_convergence_offset_y_b;
float global_mask_type;
float global_mask_sample_mode_desired;
float global_mask_num_triads_desired;
float global_mask_triad_size_desired;
float global_mask_specify_num_triads;
float global_aa_subpixel_r_offset_x_runtime;
float global_aa_subpixel_r_offset_y_runtime;
float global_aa_cubic_c;
float global_aa_gauss_sigma;
float global_geom_mode_runtime;
float global_geom_radius;
float global_geom_view_dist;
float global_geom_tilt_angle_x;
float global_geom_tilt_angle_y;
float global_geom_aspect_ratio_x;
float global_geom_aspect_ratio_y;
float global_geom_overscan_x;
float global_geom_overscan_y;
float global_border_size;
float global_border_darkness;
float global_border_compress;
float global_interlace_bff;
float global_interlace_1080i;
float global_interlace_detect_toggle;
float bloom_approx_size_x;
float bloom_approx_size_x_for_fake;
vec2 mask_resize_viewport_scale;
float geom_max_aspect_ratio;
vec2 mask_texture_small_size;
vec2 mask_texture_large_size;
float mask_triads_per_tile;
float mask_grille14_avg_color;
float mask_grille15_avg_color;
float mask_slot_avg_color;
float mask_shadow_avg_color;
float mask_grille_avg_color;
float bloom_approx_filter;
vec2 mask_resize_src_lut_size;
float max_aa_base_pixel_border;
float max_aniso_pixel_border;
float max_tiled_pixel_border;
float max_mask_texel_border;
float max_mask_tile_border;
float mask_resize_num_tiles;
float mask_start_texels;
float mask_resize_num_triads;
vec2 min_allowed_viewport_triads;
float pi;
float under_half;
float gba_gamma;
bool interlace_detect;
float ntsc_gamma;
float pal_gamma;
float crt_reference_gamma_high;
float crt_reference_gamma_low;
float lcd_reference_gamma;
float crt_office_gamma;
float lcd_office_gamma;
bool assume_opaque_alpha;
bool linearize_input;
bool gamma_encode_output;
bool gamma_aware_bilinear;

float get_crt_gamma()
{
    return global_crt_gamma;
}

float get_input_gamma()
{
    return get_crt_gamma();
}

float get_pass_input_gamma()
{
    return get_input_gamma();
}

vec4 decode_input(vec4 color)
{
    if (linearize_input)
    {
        if (assume_opaque_alpha)
        {
            return vec4(pow(color.xyz, vec3(get_pass_input_gamma())), 1.0);
        }
        else
        {
            return vec4(pow(color.xyz, vec3(get_pass_input_gamma())), color.w);
        }
    }
    else
    {
        return color;
    }
}

vec4 tex2D_linearize(sampler2D tex, vec2 tex_coords)
{
    vec4 param = texture(tex, tex_coords);
    return decode_input(param);
}

float get_pass_output_gamma()
{
    return 1.0;
}

vec4 encode_output(vec4 color)
{
    if (gamma_encode_output)
    {
        if (assume_opaque_alpha)
        {
            return vec4(pow(color.xyz, vec3(1.0 / get_pass_output_gamma())), 1.0);
        }
        else
        {
            return vec4(pow(color.xyz, vec3(1.0 / get_pass_output_gamma())), color.w);
        }
    }
    else
    {
        return color;
    }
}

void main()
{
    crt_gamma_static = 2.5;
    lcd_gamma_static = 2.2000000476837158203125;
    levels_contrast_static = 1.0;
    levels_autodim_temp = 0.5;
    halation_weight_static = 0.0;
    diffusion_weight_static = 0.07500000298023223876953125;
    bloom_underestimate_levels_static = 0.800000011920928955078125;
    bloom_excess_static = 0.0;
    bloom_approx_filter_static = 2.0;
    beam_num_scanlines = 3.0;
    beam_generalized_gaussian = true;
    beam_antialias_level = 1.0;
    beam_min_sigma_static = 0.0199999995529651641845703125;
    beam_max_sigma_static = 0.300000011920928955078125;
    beam_spot_shape_function = 0.0;
    beam_spot_power_static = 0.3333333432674407958984375;
    beam_min_shape_static = 2.0;
    beam_max_shape_static = 4.0;
    beam_shape_power_static = 0.25;
    beam_horiz_filter_static = 0.0;
    beam_horiz_sigma_static = 0.3499999940395355224609375;
    beam_horiz_linear_rgb_weight_static = 1.0;
    beam_misconvergence = true;
    convergence_offsets_r_static = vec2(0.100000001490116119384765625, 0.20000000298023223876953125);
    convergence_offsets_g_static = vec2(0.300000011920928955078125, 0.4000000059604644775390625);
    convergence_offsets_b_static = vec2(0.5, 0.60000002384185791015625);
    interlace_detect_static = true;
    interlace_1080i_static = false;
    interlace_bff_static = false;
    aa_level = 12.0;
    aa_filter = 6.0;
    aa_temporal = false;
    aa_subpixel_r_offset_static = vec2(-0.3333333432674407958984375, 0.0);
    aa_cubic_c_static = 0.5;
    aa_gauss_sigma_static = 0.5;
    mask_type_static = 1.0;
    mask_sample_mode_static = 0.0;
    mask_specify_num_triads_static = 0.0;
    mask_triad_size_desired_static = 3.0;
    mask_num_triads_desired_static = 480.0;
    mask_sinc_lobes = 3.0;
    mask_min_allowed_triad_size = 2.0;
    geom_mode_static = 0.0;
    geom_radius_static = 2.0;
    geom_view_dist_static = 2.0;
    geom_tilt_angle_static = vec2(0.0);
    geom_aspect_ratio_static = 1.31306993961334228515625;
    geom_overscan_static = vec2(1.0);
    geom_force_correct_tangent_matrix = true;
    border_size_static = 0.014999999664723873138427734375;
    border_darkness_static = 2.0;
    border_compress_static = 2.5;
    global_crt_gamma = 2.5;
    global_lcd_gamma = 2.2000000476837158203125;
    global_levels_contrast = 1.0;
    global_halation_weight = 0.0;
    global_diffusion_weight = 0.07500000298023223876953125;
    global_bloom_underestimate_levels = 0.800000011920928955078125;
    global_bloom_excess = 0.0;
    global_beam_min_sigma = 0.0199999995529651641845703125;
    global_beam_max_sigma = 0.300000011920928955078125;
    global_beam_spot_power = 0.3300000131130218505859375;
    global_beam_min_shape = 2.0;
    global_beam_max_shape = 4.0;
    global_beam_shape_power = 0.25;
    global_beam_horiz_filter = 0.0;
    global_beam_horiz_sigma = 0.3499999940395355224609375;
    global_beam_horiz_linear_rgb_weight = 1.0;
    global_convergence_offset_x_r = 0.0;
    global_convergence_offset_x_g = 0.0;
    global_convergence_offset_x_b = 0.0;
    global_convergence_offset_y_r = 0.0;
    global_convergence_offset_y_g = 0.0;
    global_convergence_offset_y_b = 0.0;
    global_mask_type = 1.0;
    global_mask_sample_mode_desired = 0.0;
    global_mask_num_triads_desired = 480.0;
    global_mask_triad_size_desired = 3.0;
    global_mask_specify_num_triads = 0.0;
    global_aa_subpixel_r_offset_x_runtime = -0.3333329856395721435546875;
    global_aa_subpixel_r_offset_y_runtime = 0.0;
    global_aa_cubic_c = 0.5;
    global_aa_gauss_sigma = 0.5;
    global_geom_mode_runtime = 0.0;
    global_geom_radius = 2.0;
    global_geom_view_dist = 2.0;
    global_geom_tilt_angle_x = 0.0;
    global_geom_tilt_angle_y = 0.0;
    global_geom_aspect_ratio_x = 432.0;
    global_geom_aspect_ratio_y = 329.0;
    global_geom_overscan_x = 1.0;
    global_geom_overscan_y = 1.0;
    global_border_size = 0.014999999664723873138427734375;
    global_border_darkness = 2.0;
    global_border_compress = 2.5;
    global_interlace_bff = 0.0;
    global_interlace_1080i = 0.0;
    global_interlace_detect_toggle = 1.0;
    bloom_approx_size_x = 320.0;
    bloom_approx_size_x_for_fake = 400.0;
    mask_resize_viewport_scale = vec2(0.0625);
    geom_max_aspect_ratio = 1.33333337306976318359375;
    mask_texture_small_size = vec2(64.0);
    mask_texture_large_size = vec2(512.0);
    mask_triads_per_tile = 8.0;
    mask_grille14_avg_color = 0.19869281351566314697265625;
    mask_grille15_avg_color = 0.20784313976764678955078125;
    mask_slot_avg_color = 0.18039216101169586181640625;
    mask_shadow_avg_color = 0.16078431904315948486328125;
    mask_grille_avg_color = mask_grille15_avg_color;
    bloom_approx_filter = bloom_approx_filter_static;
    mask_resize_src_lut_size = mask_texture_small_size;
    max_aa_base_pixel_border = 0.0;
    max_aniso_pixel_border = max_aa_base_pixel_border + 0.5;
    max_tiled_pixel_border = max_aniso_pixel_border;
    max_mask_texel_border = ceil(max_tiled_pixel_border);
    max_mask_tile_border = max_mask_texel_border / (mask_min_allowed_triad_size * mask_triads_per_tile);
    mask_resize_num_tiles = 2.0;
    mask_start_texels = 0.0;
    mask_resize_num_triads = mask_resize_num_tiles * mask_triads_per_tile;
    min_allowed_viewport_triads = vec2(mask_resize_num_triads) / mask_resize_viewport_scale;
    pi = 3.1415927410125732421875;
    under_half = 0.4995000064373016357421875;
    gba_gamma = 3.5;
    interlace_detect = global_interlace_detect_toggle != 0.0;
    ntsc_gamma = 2.2000000476837158203125;
    pal_gamma = 2.7999999523162841796875;
    crt_reference_gamma_high = 2.5;
    crt_reference_gamma_low = 2.349999904632568359375;
    lcd_reference_gamma = 2.5;
    crt_office_gamma = 2.2000000476837158203125;
    lcd_office_gamma = 2.2000000476837158203125;
    assume_opaque_alpha = false;
    linearize_input = true;
    gamma_encode_output = false;
    gamma_aware_bilinear = !linearize_input;
    if (interlace_detect)
    {
        vec2 v_step = vec2(0.0, uv_step.y);
        vec2 param = tex_uv;
        vec3 curr_line = tex2D_linearize(Source, param).xyz;
        vec2 param_1 = tex_uv - v_step;
        vec3 last_line = tex2D_linearize(Source, param_1).xyz;
        vec2 param_2 = tex_uv + v_step;
        vec3 next_line = tex2D_linearize(Source, param_2).xyz;
        vec3 interpolated_line = (last_line + next_line) * 0.5;
        float modulus = interlaced + 1.0;
        float field_offset = mod(float(params.FrameCount) + global_interlace_bff, modulus);
        float curr_line_texel = tex_uv.y * params.SourceSize.y;
        float line_num_last = floor(curr_line_texel - under_half);
        float wrong_field = mod(line_num_last + field_offset, modulus);
        vec3 color = mix(curr_line, interpolated_line, vec3(wrong_field));
        vec4 param_3 = vec4(color, 1.0);
        FragColor = encode_output(param_3);
    }
    else
    {
        vec2 param_4 = tex_uv;
        vec4 param_5 = tex2D_linearize(Source, param_4);
        FragColor = encode_output(param_5);
    }
}

