#version 430

layout(binding = 0, std140) uniform UBO
{
    mat4 MVP;
    float crt_gamma;
    float lcd_gamma;
    float levels_contrast;
    float halation_weight;
    float diffusion_weight;
    float bloom_underestimate_levels;
    float bloom_excess;
    float beam_min_sigma;
    float beam_max_sigma;
    float beam_spot_power;
    float beam_min_shape;
    float beam_max_shape;
    float beam_shape_power;
    float beam_horiz_filter;
    float beam_horiz_sigma;
    float beam_horiz_linear_rgb_weight;
    float convergence_offset_x_r;
    float convergence_offset_x_g;
    float convergence_offset_x_b;
    float convergence_offset_y_r;
    float convergence_offset_y_g;
    float convergence_offset_y_b;
    float mask_type;
    float mask_sample_mode_desired;
    float mask_num_triads_desired;
    float mask_triad_size_desired;
    float mask_specify_num_triads;
    float aa_subpixel_r_offset_x_runtime;
    float aa_subpixel_r_offset_y_runtime;
    float aa_cubic_c;
    float aa_gauss_sigma;
    float geom_mode_runtime;
    float geom_radius;
    float geom_view_dist;
    float geom_tilt_angle_x;
    float geom_tilt_angle_y;
    float geom_aspect_ratio_x;
    float geom_aspect_ratio_y;
    float geom_overscan_x;
    float geom_overscan_y;
    float border_size;
    float border_darkness;
    float border_compress;
    float interlace_bff;
    float interlace_1080i;
    float interlace_detect_toggle;
} global;

struct Push
{
    vec4 SourceSize;
    vec4 OriginalSize;
    vec4 OutputSize;
    uint FrameCount;
    vec4 MASKED_SCANLINESSize;
    vec4 HALATION_BLURSize;
    vec4 BRIGHTPASSSize;
};

uniform Push params;

layout(location = 0) in vec4 Position;
layout(location = 0) out vec2 tex_uv;
layout(location = 1) in vec2 TexCoord;
layout(location = 1) out vec4 video_and_texture_size_inv;
layout(location = 2) out vec2 output_size_inv;
layout(location = 4) out vec4 geom_aspect_and_overscan;
layout(location = 5) out vec3 global_to_local_row0;
layout(location = 6) out vec3 global_to_local_row1;
layout(location = 7) out vec3 global_to_local_row2;
layout(location = 3) out vec3 eye_pos_local;
float crt_gamma_static;
float lcd_gamma_static;
float levels_contrast_static;
float levels_autodim_temp;
float halation_weight_static;
float diffusion_weight_static;
float bloom_underestimate_levels_static;
float bloom_excess_static;
float bloom_approx_filter_static;
float beam_num_scanlines;
bool beam_generalized_gaussian;
float beam_antialias_level;
float beam_min_sigma_static;
float beam_max_sigma_static;
float beam_spot_shape_function;
float beam_spot_power_static;
float beam_min_shape_static;
float beam_max_shape_static;
float beam_shape_power_static;
float beam_horiz_filter_static;
float beam_horiz_sigma_static;
float beam_horiz_linear_rgb_weight_static;
bool beam_misconvergence;
vec2 convergence_offsets_r_static;
vec2 convergence_offsets_g_static;
vec2 convergence_offsets_b_static;
bool interlace_detect_static;
bool interlace_1080i_static;
bool interlace_bff_static;
float aa_level;
float aa_filter;
bool aa_temporal;
vec2 aa_subpixel_r_offset_static;
float aa_cubic_c_static;
float aa_gauss_sigma_static;
float mask_type_static;
float mask_sample_mode_static;
float mask_specify_num_triads_static;
float mask_triad_size_desired_static;
float mask_num_triads_desired_static;
float mask_sinc_lobes;
float mask_min_allowed_triad_size;
float geom_mode_static;
float geom_radius_static;
float geom_view_dist_static;
vec2 geom_tilt_angle_static;
float geom_aspect_ratio_static;
vec2 geom_overscan_static;
bool geom_force_correct_tangent_matrix;
float border_size_static;
float border_darkness_static;
float border_compress_static;
float bloom_approx_size_x;
float bloom_approx_size_x_for_fake;
vec2 mask_resize_viewport_scale;
float geom_max_aspect_ratio;
vec2 mask_texture_small_size;
vec2 mask_texture_large_size;
float mask_triads_per_tile;
float mask_grille14_avg_color;
float mask_grille15_avg_color;
float mask_slot_avg_color;
float mask_shadow_avg_color;
float mask_grille_avg_color;
float bloom_approx_filter;
vec2 mask_resize_src_lut_size;
float max_aa_base_pixel_border;
float max_aniso_pixel_border;
float max_tiled_pixel_border;
float max_mask_texel_border;
float max_mask_tile_border;
float mask_resize_num_tiles;
float mask_start_texels;
float mask_resize_num_triads;
vec2 min_allowed_viewport_triads;
float pi;
float under_half;
float global_crt_gamma;
float global_lcd_gamma;
float global_levels_contrast;
float global_halation_weight;
float global_diffusion_weight;
float global_bloom_underestimate_levels;
float global_bloom_excess;
float global_beam_min_sigma;
float global_beam_max_sigma;
float global_beam_spot_power;
float global_beam_min_shape;
float global_beam_max_shape;
float global_beam_shape_power;
float global_beam_horiz_filter;
float global_beam_horiz_sigma;
float global_beam_horiz_linear_rgb_weight;
float global_convergence_offset_x_r;
float global_convergence_offset_x_g;
float global_convergence_offset_x_b;
float global_convergence_offset_y_r;
float global_convergence_offset_y_g;
float global_convergence_offset_y_b;
float global_mask_type;
float global_mask_sample_mode_desired;
float global_mask_num_triads_desired;
float global_mask_triad_size_desired;
float global_mask_specify_num_triads;
float global_aa_subpixel_r_offset_x_runtime;
float global_aa_subpixel_r_offset_y_runtime;
float global_aa_cubic_c;
float global_aa_gauss_sigma;
float global_geom_mode_runtime;
float global_geom_radius;
float global_geom_view_dist;
float global_geom_tilt_angle_x;
float global_geom_tilt_angle_y;
float global_geom_aspect_ratio_x;
float global_geom_aspect_ratio_y;
float global_geom_overscan_x;
float global_geom_overscan_y;
float global_border_size;
float global_border_darkness;
float global_border_compress;
float global_interlace_bff;
float global_interlace_1080i;
float global_interlace_detect_toggle;
float gba_gamma;
bool interlace_detect;
float ntsc_gamma;
float pal_gamma;
float crt_reference_gamma_high;
float crt_reference_gamma_low;
float lcd_reference_gamma;
float crt_office_gamma;
float lcd_office_gamma;
bool assume_opaque_alpha;
bool linearize_input;
bool gamma_encode_output;
bool gamma_aware_bilinear;
float aa_pixel_diameter;
float aa_lanczos_lobes;
float aa_gauss_support;
float aa_tent_support;
vec2 aa_xy_axis_importance;
float aa_box_support;
float aa_cubic_support;
float aa_cubic_b;
float cubic_branch1_x3_coeff;
float cubic_branch1_x2_coeff;
float cubic_branch1_x0_coeff;
float cubic_branch2_x3_coeff;
float cubic_branch2_x2_coeff;
float cubic_branch2_x1_coeff;
float cubic_branch2_x0_coeff;

vec2 get_aspect_vector(float geom_aspect_ratio)
{
    float geom_clamped_aspect_ratio = min(geom_aspect_ratio, geom_max_aspect_ratio);
    vec2 geom_aspect = normalize(vec2(geom_clamped_aspect_ratio, 1.0));
    return geom_aspect;
}

vec2 get_geom_overscan_vector()
{
    return vec2(global_geom_overscan_x, global_geom_overscan_y);
}

vec2 get_geom_tilt_angle_vector()
{
    return vec2(global_geom_tilt_angle_x, global_geom_tilt_angle_y);
}

vec3 sphere_uv_to_xyz(vec2 video_uv, vec2 geom_aspect)
{
    vec2 square_uv = video_uv * geom_aspect;
    vec2 square_uv_unit = normalize(square_uv);
    float arc_len = square_uv.y / square_uv_unit.y;
    float angle_from_image_center = arc_len / global_geom_radius;
    float xy_dist_from_sphere_center = sin(angle_from_image_center) * global_geom_radius;
    vec2 xy_pos = square_uv_unit * xy_dist_from_sphere_center;
    float z_pos = cos(angle_from_image_center) * global_geom_radius;
    vec3 intersection_pos_local = vec3(xy_pos.x, -xy_pos.y, z_pos);
    return intersection_pos_local;
}

vec3 sphere_alt_uv_to_xyz(vec2 video_uv, vec2 geom_aspect)
{
    vec2 square_uv = video_uv * geom_aspect;
    vec2 arc_len = square_uv;
    vec2 angle_from_image_center = arc_len / vec2(global_geom_radius);
    vec2 xy_pos = sin(angle_from_image_center) * global_geom_radius;
    float z_pos = sqrt((global_geom_radius * global_geom_radius) - dot(xy_pos, xy_pos));
    return vec3(xy_pos.x, -xy_pos.y, z_pos);
}

vec3 cylinder_uv_to_xyz(vec2 video_uv, vec2 geom_aspect)
{
    vec2 square_uv = video_uv * geom_aspect;
    float arc_len = square_uv.x;
    float angle_from_image_center = arc_len / global_geom_radius;
    float x_pos = sin(angle_from_image_center) * global_geom_radius;
    float z_pos = cos(angle_from_image_center) * global_geom_radius;
    vec3 intersection_pos_local = vec3(x_pos, -square_uv.y, z_pos);
    return intersection_pos_local;
}

vec3 uv_to_xyz(vec2 uv, vec2 geom_aspect, float geom_mode)
{
    vec3 _453;
    if (geom_mode < 1.5)
    {
        vec2 param = uv;
        vec2 param_1 = geom_aspect;
        _453 = sphere_uv_to_xyz(param, param_1);
    }
    else
    {
        vec3 _464;
        if (geom_mode < 2.5)
        {
            vec2 param_2 = uv;
            vec2 param_3 = geom_aspect;
            _464 = sphere_alt_uv_to_xyz(param_2, param_3);
        }
        else
        {
            vec2 param_4 = uv;
            vec2 param_5 = geom_aspect;
            _464 = cylinder_uv_to_xyz(param_4, param_5);
        }
        _453 = _464;
    }
    return _453;
}

vec3 get_ideal_global_eye_pos_for_points(inout vec3 eye_pos, vec2 geom_aspect, vec3 global_coords[9], int num_points)
{
    int max_centering_iters = 1;
    vec3 eyespace_coords[9];
    float _660;
    float _673;
    float _686;
    float _699;
    for (int iter = 0; iter < max_centering_iters; iter++)
    {
        for (int i = 0; i < num_points; i++)
        {
            eyespace_coords[i] = global_coords[i] - eye_pos;
        }
        float abs_radius = abs(global_geom_radius);
        vec2 offset_dr_min = vec2(10.0 * abs_radius, 10.0 * abs_radius);
        vec2 offset_ul_max = vec2((-10.0) * abs_radius, (-10.0) * abs_radius);
        for (int i_1 = 0; i_1 < num_points; i_1++)
        {
            vec2 flipy = vec2(1.0, -1.0);
            vec3 eyespace_xyz = eyespace_coords[i_1];
            vec2 offset_dr = eyespace_xyz.xy - ((vec2(-0.5) * (geom_aspect * (-eyespace_xyz.z))) / (flipy * global_geom_view_dist));
            vec2 offset_ul = eyespace_xyz.xy - ((vec2(0.5) * (geom_aspect * (-eyespace_xyz.z))) / (flipy * global_geom_view_dist));
            offset_dr_min = min(offset_dr_min, offset_dr);
            offset_ul_max = max(offset_ul_max, offset_ul);
        }
        vec2 center_offset = (offset_ul_max + offset_dr_min) * 0.5;
        vec3 _592 = eye_pos;
        vec2 _594 = _592.xy + center_offset;
        eye_pos.x = _594.x;
        eye_pos.y = _594.y;
        for (int i_2 = 0; i_2 < num_points; i_2++)
        {
            eyespace_coords[i_2] = global_coords[i_2] - eye_pos;
        }
        float offset_z_max = ((-10.0) * global_geom_radius) * global_geom_view_dist;
        for (int i_3 = 0; i_3 < num_points; i_3++)
        {
            vec3 eyespace_xyz_flipy = eyespace_coords[i_3] * vec3(1.0, -1.0, 1.0);
            vec4 offset_zzzz = eyespace_xyz_flipy.zzzz + ((eyespace_xyz_flipy.xyxy * global_geom_view_dist) / (vec4(-0.5, -0.5, 0.5, 0.5) * vec4(geom_aspect, geom_aspect)));
            if (eyespace_xyz_flipy.x < 0.0)
            {
                _660 = max(offset_z_max, offset_zzzz.x);
            }
            else
            {
                _660 = offset_z_max;
            }
            offset_z_max = _660;
            if (eyespace_xyz_flipy.y < 0.0)
            {
                _673 = max(offset_z_max, offset_zzzz.y);
            }
            else
            {
                _673 = offset_z_max;
            }
            offset_z_max = _673;
            if (eyespace_xyz_flipy.x > 0.0)
            {
                _686 = max(offset_z_max, offset_zzzz.z);
            }
            else
            {
                _686 = offset_z_max;
            }
            offset_z_max = _686;
            if (eyespace_xyz_flipy.y > 0.0)
            {
                _699 = max(offset_z_max, offset_zzzz.w);
            }
            else
            {
                _699 = offset_z_max;
            }
            offset_z_max = _699;
            offset_z_max = max(offset_z_max, eyespace_xyz_flipy.z);
        }
        eye_pos.z += offset_z_max;
    }
    return eye_pos;
}

vec3 get_ideal_global_eye_pos(mat3 local_to_global, vec2 geom_aspect, float geom_mode)
{
    vec3 high_view = vec3(0.0, geom_aspect.y, -global_geom_view_dist);
    vec3 low_view = high_view * vec3(1.0, -1.0, 1.0);
    float len_sq = dot(high_view, high_view);
    float fov = abs(acos(dot(high_view, low_view) / len_sq));
    float eye_z_spherical = global_geom_radius / sin(fov * 0.5);
    vec3 _756;
    if (geom_mode < 2.5)
    {
        _756 = vec3(0.0, 0.0, eye_z_spherical);
    }
    else
    {
        _756 = vec3(0.0, 0.0, max(global_geom_view_dist, eye_z_spherical));
    }
    vec3 eye_pos = _756;
    int num_points = 9;
    vec2 param = vec2(0.0);
    vec2 param_1 = geom_aspect;
    float param_2 = geom_mode;
    vec3 global_coords[9];
    global_coords[0] = uv_to_xyz(param, param_1, param_2) * local_to_global;
    vec2 param_3 = vec2(0.0, -0.5);
    vec2 param_4 = geom_aspect;
    float param_5 = geom_mode;
    global_coords[1] = uv_to_xyz(param_3, param_4, param_5) * local_to_global;
    vec2 param_6 = vec2(0.0, 0.5);
    vec2 param_7 = geom_aspect;
    float param_8 = geom_mode;
    global_coords[2] = uv_to_xyz(param_6, param_7, param_8) * local_to_global;
    vec2 param_9 = vec2(-0.5, 0.0);
    vec2 param_10 = geom_aspect;
    float param_11 = geom_mode;
    global_coords[3] = uv_to_xyz(param_9, param_10, param_11) * local_to_global;
    vec2 param_12 = vec2(0.5, 0.0);
    vec2 param_13 = geom_aspect;
    float param_14 = geom_mode;
    global_coords[4] = uv_to_xyz(param_12, param_13, param_14) * local_to_global;
    vec2 param_15 = vec2(-0.5);
    vec2 param_16 = geom_aspect;
    float param_17 = geom_mode;
    global_coords[5] = uv_to_xyz(param_15, param_16, param_17) * local_to_global;
    vec2 param_18 = vec2(0.5, -0.5);
    vec2 param_19 = geom_aspect;
    float param_20 = geom_mode;
    global_coords[6] = uv_to_xyz(param_18, param_19, param_20) * local_to_global;
    vec2 param_21 = vec2(-0.5, 0.5);
    vec2 param_22 = geom_aspect;
    float param_23 = geom_mode;
    global_coords[7] = uv_to_xyz(param_21, param_22, param_23) * local_to_global;
    vec2 param_24 = vec2(0.5);
    vec2 param_25 = geom_aspect;
    float param_26 = geom_mode;
    global_coords[8] = uv_to_xyz(param_24, param_25, param_26) * local_to_global;
    float num_negative_z_coords = 0.0;
    for (int i = 0; i < num_points; i++)
    {
        num_negative_z_coords += float(global_coords[0].z < 0.0);
    }
    vec3 _884;
    if (num_negative_z_coords > 0.5)
    {
        _884 = eye_pos;
    }
    else
    {
        vec3 param_27 = eye_pos;
        vec2 param_28 = geom_aspect;
        vec3 param_29[9] = global_coords;
        int param_30 = num_points;
        vec3 _897 = get_ideal_global_eye_pos_for_points(param_27, param_28, param_29, param_30);
        _884 = _897;
    }
    return _884;
}

void main()
{
    crt_gamma_static = 2.5;
    lcd_gamma_static = 2.2000000476837158203125;
    levels_contrast_static = 1.0;
    levels_autodim_temp = 0.5;
    halation_weight_static = 0.0;
    diffusion_weight_static = 0.07500000298023223876953125;
    bloom_underestimate_levels_static = 0.800000011920928955078125;
    bloom_excess_static = 0.0;
    bloom_approx_filter_static = 2.0;
    beam_num_scanlines = 3.0;
    beam_generalized_gaussian = true;
    beam_antialias_level = 1.0;
    beam_min_sigma_static = 0.0199999995529651641845703125;
    beam_max_sigma_static = 0.300000011920928955078125;
    beam_spot_shape_function = 0.0;
    beam_spot_power_static = 0.3333333432674407958984375;
    beam_min_shape_static = 2.0;
    beam_max_shape_static = 4.0;
    beam_shape_power_static = 0.25;
    beam_horiz_filter_static = 0.0;
    beam_horiz_sigma_static = 0.3499999940395355224609375;
    beam_horiz_linear_rgb_weight_static = 1.0;
    beam_misconvergence = true;
    convergence_offsets_r_static = vec2(0.100000001490116119384765625, 0.20000000298023223876953125);
    convergence_offsets_g_static = vec2(0.300000011920928955078125, 0.4000000059604644775390625);
    convergence_offsets_b_static = vec2(0.5, 0.60000002384185791015625);
    interlace_detect_static = true;
    interlace_1080i_static = false;
    interlace_bff_static = false;
    aa_level = 12.0;
    aa_filter = 6.0;
    aa_temporal = false;
    aa_subpixel_r_offset_static = vec2(-0.3333333432674407958984375, 0.0);
    aa_cubic_c_static = 0.5;
    aa_gauss_sigma_static = 0.5;
    mask_type_static = 1.0;
    mask_sample_mode_static = 0.0;
    mask_specify_num_triads_static = 0.0;
    mask_triad_size_desired_static = 3.0;
    mask_num_triads_desired_static = 480.0;
    mask_sinc_lobes = 3.0;
    mask_min_allowed_triad_size = 2.0;
    geom_mode_static = 0.0;
    geom_radius_static = 2.0;
    geom_view_dist_static = 2.0;
    geom_tilt_angle_static = vec2(0.0);
    geom_aspect_ratio_static = 1.31306993961334228515625;
    geom_overscan_static = vec2(1.0);
    geom_force_correct_tangent_matrix = true;
    border_size_static = 0.014999999664723873138427734375;
    border_darkness_static = 2.0;
    border_compress_static = 2.5;
    bloom_approx_size_x = 320.0;
    bloom_approx_size_x_for_fake = 400.0;
    mask_resize_viewport_scale = vec2(0.0625);
    geom_max_aspect_ratio = 1.33333337306976318359375;
    mask_texture_small_size = vec2(64.0);
    mask_texture_large_size = vec2(512.0);
    mask_triads_per_tile = 8.0;
    mask_grille14_avg_color = 0.19869281351566314697265625;
    mask_grille15_avg_color = 0.20784313976764678955078125;
    mask_slot_avg_color = 0.18039216101169586181640625;
    mask_shadow_avg_color = 0.16078431904315948486328125;
    mask_grille_avg_color = mask_grille15_avg_color;
    bloom_approx_filter = bloom_approx_filter_static;
    mask_resize_src_lut_size = mask_texture_small_size;
    max_aa_base_pixel_border = 0.0;
    max_aniso_pixel_border = max_aa_base_pixel_border + 0.5;
    max_tiled_pixel_border = max_aniso_pixel_border;
    max_mask_texel_border = ceil(max_tiled_pixel_border);
    max_mask_tile_border = max_mask_texel_border / (mask_min_allowed_triad_size * mask_triads_per_tile);
    mask_resize_num_tiles = 2.0;
    mask_start_texels = 0.0;
    mask_resize_num_triads = mask_resize_num_tiles * mask_triads_per_tile;
    min_allowed_viewport_triads = vec2(mask_resize_num_triads) / mask_resize_viewport_scale;
    pi = 3.1415927410125732421875;
    under_half = 0.4995000064373016357421875;
    global_crt_gamma = 2.5;
    global_lcd_gamma = 2.2000000476837158203125;
    global_levels_contrast = 1.0;
    global_halation_weight = 0.0;
    global_diffusion_weight = 0.07500000298023223876953125;
    global_bloom_underestimate_levels = 0.800000011920928955078125;
    global_bloom_excess = 0.0;
    global_beam_min_sigma = 0.0199999995529651641845703125;
    global_beam_max_sigma = 0.300000011920928955078125;
    global_beam_spot_power = 0.3300000131130218505859375;
    global_beam_min_shape = 2.0;
    global_beam_max_shape = 4.0;
    global_beam_shape_power = 0.25;
    global_beam_horiz_filter = 0.0;
    global_beam_horiz_sigma = 0.3499999940395355224609375;
    global_beam_horiz_linear_rgb_weight = 1.0;
    global_convergence_offset_x_r = 0.0;
    global_convergence_offset_x_g = 0.0;
    global_convergence_offset_x_b = 0.0;
    global_convergence_offset_y_r = 0.0;
    global_convergence_offset_y_g = 0.0;
    global_convergence_offset_y_b = 0.0;
    global_mask_type = 1.0;
    global_mask_sample_mode_desired = 0.0;
    global_mask_num_triads_desired = 480.0;
    global_mask_triad_size_desired = 3.0;
    global_mask_specify_num_triads = 0.0;
    global_aa_subpixel_r_offset_x_runtime = -0.3333329856395721435546875;
    global_aa_subpixel_r_offset_y_runtime = 0.0;
    global_aa_cubic_c = 0.5;
    global_aa_gauss_sigma = 0.5;
    global_geom_mode_runtime = 0.0;
    global_geom_radius = 2.0;
    global_geom_view_dist = 2.0;
    global_geom_tilt_angle_x = 0.0;
    global_geom_tilt_angle_y = 0.0;
    global_geom_aspect_ratio_x = 432.0;
    global_geom_aspect_ratio_y = 329.0;
    global_geom_overscan_x = 1.0;
    global_geom_overscan_y = 1.0;
    global_border_size = 0.014999999664723873138427734375;
    global_border_darkness = 2.0;
    global_border_compress = 2.5;
    global_interlace_bff = 0.0;
    global_interlace_1080i = 0.0;
    global_interlace_detect_toggle = 1.0;
    gba_gamma = 3.5;
    interlace_detect = global_interlace_detect_toggle != 0.0;
    ntsc_gamma = 2.2000000476837158203125;
    pal_gamma = 2.7999999523162841796875;
    crt_reference_gamma_high = 2.5;
    crt_reference_gamma_low = 2.349999904632568359375;
    lcd_reference_gamma = 2.5;
    crt_office_gamma = 2.2000000476837158203125;
    lcd_office_gamma = 2.2000000476837158203125;
    assume_opaque_alpha = false;
    linearize_input = false;
    gamma_encode_output = true;
    gamma_aware_bilinear = !linearize_input;
    aa_pixel_diameter = 1.0;
    aa_lanczos_lobes = 3.0;
    aa_gauss_support = 1.0 / aa_pixel_diameter;
    aa_tent_support = 1.0 / aa_pixel_diameter;
    vec2 _293;
    if (aa_filter < 5.5)
    {
        _293 = vec2(1.0);
    }
    else
    {
        vec2 _300;
        if (aa_filter < 8.5)
        {
            _300 = vec2(1.0, 0.0);
        }
        else
        {
            vec2 _308;
            if (aa_filter < 9.5)
            {
                _308 = vec2(1.0, 1.0 / aa_lanczos_lobes);
            }
            else
            {
                _308 = vec2(1.0);
            }
            _300 = _308;
        }
        _293 = _300;
    }
    aa_xy_axis_importance = _293;
    aa_box_support = 0.5;
    aa_cubic_support = 2.0;
    gl_Position = global.MVP * Position;
    tex_uv = TexCoord;
    video_and_texture_size_inv = vec4(1.0) / vec4(params.SourceSize.xy, params.SourceSize.xy);
    output_size_inv = vec2(1.0) / params.OutputSize.xy;
    float viewport_aspect_ratio = params.OutputSize.x / params.OutputSize.y;
    float param = viewport_aspect_ratio;
    vec2 geom_aspect = get_aspect_vector(param);
    vec2 geom_overscan = get_geom_overscan_vector();
    geom_aspect_and_overscan = vec4(geom_aspect, geom_overscan);
    vec2 geom_tilt_angle = get_geom_tilt_angle_vector();
    vec2 sin_tilt = sin(geom_tilt_angle);
    vec2 cos_tilt = cos(geom_tilt_angle);
    mat3 rot_x_matrix = mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, cos_tilt.y, -sin_tilt.y), vec3(0.0, sin_tilt.y, cos_tilt.y));
    mat3 rot_y_matrix = mat3(vec3(cos_tilt.x, 0.0, sin_tilt.x), vec3(0.0, 1.0, 0.0), vec3(-sin_tilt.x, 0.0, cos_tilt.x));
    mat3 local_to_global = rot_x_matrix * rot_y_matrix;
    mat3 global_to_local = transpose(local_to_global);
    global_to_local_row0 = vec3(global_to_local[0].x, global_to_local[0].y, global_to_local[0].z);
    global_to_local_row1 = vec3(global_to_local[1].x, global_to_local[1].y, global_to_local[1].z);
    global_to_local_row2 = vec3(global_to_local[2].x, global_to_local[2].y, global_to_local[2].z);
    float geom_mode = global_geom_mode_runtime;
    mat3 param_1 = local_to_global;
    vec2 param_2 = geom_aspect;
    float param_3 = geom_mode;
    vec3 eye_pos_global = get_ideal_global_eye_pos(param_1, param_2, param_3);
    eye_pos_local = eye_pos_global * global_to_local;
}

