#version 430

layout(binding = 0, std140) uniform UBO
{
    mat4 MVP;
} global;

struct Push
{
    vec4 SourceSize;
    float trY;
    float trU;
    float trV;
};

uniform Push registers;

layout(location = 0) in vec4 Position;
layout(location = 0) out vec2 vTexCoord;
layout(location = 1) in vec2 TexCoord;
layout(location = 1) out vec4 t1;
layout(location = 2) out vec4 t2;
layout(location = 3) out vec4 t3;
vec3 yuv_threshold;

void main()
{
    yuv_threshold = vec3(registers.trY / 255.0, registers.trU / 255.0, registers.trV / 255.0);
    gl_Position = global.MVP * Position;
    vTexCoord = TexCoord;
    float dx = registers.SourceSize.z;
    float dy = registers.SourceSize.w;
    t1 = vTexCoord.xxxy + vec4(-dx, 0.0, dx, -dy);
    t2 = vTexCoord.xxxy + vec4(-dx, 0.0, dx, 0.0);
    t3 = vTexCoord.xxxy + vec4(-dx, 0.0, dx, dy);
}

